// cc-by 3.0 Austria, (c) 2010 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/

import jku.ssw.javafx.modifier.*;
import jku.ssw.javafx.modifier.B.setProtectedVar;

var a : A;

println("INIT");
a = A { publicInitVar : 1; publicVar : 1 };
a.printStatus();
println("");


println("SETTER");
a.setScriptVar(2);
a.setPublicReadVar(2);
a.setPublicInitVar(2);
a.printStatus();
println("");


println("B");
B.setPackageVar(a, 3);
setProtectedVar(a, 3);
a.printStatus();
println("");


println("PUBLIC");
a.publicVar = 4;
a.printStatus();
println("");

println("INHERITED");
var c : C = C {  };
a.printStatus();
println("");

class C extends A {
	public function getProtectedVarFromC() : Integer {
	    protectedVar;
	}

	public function setProtectedVarFromC(value : Integer) {
	    protectedVar = value;
	}
}

println("INHERITED 2");
c.setProtectedVarFromC(6);
c.printStatus();
println("");


println("READ");
println("a.publicVar:          {a.publicVar}");
println("a.publicInitVar:      {a.publicInitVar}");
println("a.publicReadVar:      {a.publicReadVar}");
println("B.getProtectedVar(a): {B.getProtectedVar(a)}");
println("B.getPackageVar(a):   {B.getPackageVar(a)}");
println("a.getScriptVar():     {a.getScriptVar()}");


