// cc-by 3.0 Austria, (c) 2010 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/


import javafx.animation.Interpolator;
import javafx.animation.KeyFrame;
import javafx.animation.KeyValue;
import javafx.animation.KeyValueTarget;
import javafx.animation.Timeline;

var i = 0 on replace { println(i) }

var from0To9 = Timeline {
    keyFrames :
    [
    	KeyFrame {
    		time : 0s
    		values : KeyValue {
    		    target : IntTarget {
    		    	val: bind i with inverse
    		    }
    		    value : function() { 0 }
    		    interpolate : Interpolator.LINEAR
    		}
    	}
    	KeyFrame {
    		time : 3s
    		values : KeyValue {
				target : IntTarget {
					val: bind i with inverse
				}
				value : function() { 9 }
				interpolate : Interpolator.LINEAR
			}
    	}
    ]
}

from0To9.play();


class IntTarget extends KeyValueTarget {
    public var val : Integer;

    override function unwrap() : KeyValueTarget {
        this
    }
    override function set(value : Object) {
        val = value as Integer
    }
    override function get() {
        val
    }
    override function setValue(value: Object) {
        set(value)
    }
    override function getValue() {
        get()
    }
    override function getType() {
        KeyValueTarget.Type.INTEGER
    }
}
