// cc-by 3.0 Austria, (c) 2010 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/

var a : Integer = 1;
var b : Integer = 2;

println(" bind expression");

var x = bind a + b;
println(x);

a += 1;
println(x);

b += 1;
println(x);


println("\n bind if");

var statement = bind if (a > b) "a({a}) > b({b})" else "a({a}) <= b({b})";
println(statement);

a = 10;
println(statement);


println("\n bind for");

def seq : String[] = bind for (i in [a..b]) "{i}";
println(seq);

a = 1;
println(seq);


println("\n bind block");

var x2 = bind {
	def MY_A = a;
	def MY_B = b;
	a * 2
} on replace { println("new x2 : {x2}"); }

println("\n update b");
b = 20;
println(x2);

println("\n update a");
a = 1;
println(x2);

println("\n update a");
a = 2;
println(x2);

